#!/usr/bin/perl -w

# Copyright (c) Ensim Corporation 2000, 2001, 2000   All Rights Reserved.
#
# This software is furnished under a license and may be used and copied
# only  in  accordance  with  the  terms  of such  license and with the
# inclusion of the above copyright notice. This software or any other
# copies thereof may not be provided or otherwise made available to any
# other person. No title to and ownership of the software is hereby
# transferred.
#
# The information in this software is subject to change without notice
# and  should  not be  construed  as  a commitment by Ensim Corporation.
# Ensim assumes no responsibility for the use or  reliability  of its
# software on equipment which is not supplied by Ensim.
#
# This module handles the configuration files of apache and ftp, as
# used by virtual hosting.
#
#

package VHMivaConf ;

push @INC, ($ENV{'OCW_SVCPATH'} || "/usr/lib/opcenter") . "/mivamerchant_unl";

use strict ;
require mivamerchant ;



#######################################

sub RebuildMivaConf
{
	my ($key,$val) ;
	my ($domain) ;
	my ($line) ;
	my (%mv) ;
	my (%mivavhosts) ;
	my ($mv) ;
	my ($found) ;
	my ($stamp) ;

	# Make backup of files to be changed
	# 
	system ("cp -a $mivamerchant::MIVACONF $mivamerchant::MIVACONF.ensim.backup") ;
	system ("cp -a $mivamerchant::MIVAAUTH $mivamerchant::MIVAAUTH.ensim.backup") ;


	# Open all file handles first
	#
	unless (open (MVCONF,$mivamerchant::MIVACONF)) {
		return "Can not open miva conf" ;
	}
	unless (open (MVAUTH,$mivamerchant::MIVAAUTH)) {
		close(MVCONF) ;
		return "Can not open miva authfile" ;
	}
	unless (open (MVCONFTMP,">$mivamerchant::MIVACONF.tmp")) {
		close (MVCONF) ;
		close (MVAUTH) ;
		return "Can not write miva conf tmp" ;
	}
	unless (open (MVAUTHTMP,">$mivamerchant::MIVAAUTH.tmp")) {
		close (MVCONF) ;
		close (MVAUTH) ;
		close (MVCONFTMP) ;
		return "Can not write miva authfile tmp" ;
	}

	$found = 0 ;
	$line = <MVCONF> ;
	while ( $line ) {
		if ( $line =~ /^#WEBppliance-enabled/ ) {
			$stamp = $line ;
			$found = 1 ;
			last ;
		}
		else {
			print MVCONFTMP $line ;
		}
		$line = <MVCONF> ;
	}
	if ( $found == 0 ) {
		close (MVCONF) ;
		close (MVAUTH) ;
		close (MVCONFTMP) ;
		close (MVAUTHTMP) ;
		return "Miva conf does not contain valid Ensim Marker\nShould look like this starting at char 1: #WEBppliance-enabled" ;
	}

	$found = 0 ;
	$line = <MVAUTH> ;
	while ( $line ) {
		if ( $line =~ /^#WEBppliance-enabled/ ) {
			$stamp = $line ;
			$found = 1 ;
			last ;
		}
		else {
			print MVAUTHTMP $line ;
		}
		$line = <MVAUTH> ;
	}
	if ( $found == 0 ) {
		close (MVCONF) ;
		close (MVAUTH) ;
		close (MVCONFTMP) ;
		close (MVAUTHTMP) ;
		return "Miva authfile does not contain valid Ensim Marker\nShould look like this starting at char 1: #WEBeppliance-enabled" ;
	}


	print MVCONFTMP $stamp ;
	print MVCONFTMP "# ENSIM CONTROLLED\n" ;
	print MVCONFTMP "#\n" ;

	print MVAUTHTMP $stamp ;
	print MVAUTHTMP "# ENSIM CONTROLLED\n" ;
	print MVAUTHTMP "#\n" ;

	GetMivaVHosts(\%mivavhosts) ;
	while (($key,$val) = each %mivavhosts) { 
		eval($val) ;
		$domain = $key ;
		print MVCONFTMP "\n" ;
		print MVCONFTMP "# Virtual Host Settings For Domain: $domain\n" ;
		print MVCONFTMP "<VirtualHost $mv{WebServerName}>\n" ;
		print MVCONFTMP "ServerAdmin=$mv{mivawebadmin}\n" ;
		print MVCONFTMP "mivaroot=$mv{mivaroot}\n" ;
		print MVCONFTMP "</VirtualHost>\n" ;

		print MVAUTHTMP "\n" ;
		print MVAUTHTMP "# Authorized Miva User For Domain: $domain\n" ;
		print MVAUTHTMP "$mv{User}=$mv{mivadata}\n" ;
	}

	close (MVCONF) ;
	close (MVAUTH) ;
	close (MVCONFTMP) ;
	close (MVAUTHTMP) ;

	# Replace old files
	system ("mv $mivamerchant::MIVACONF.tmp $mivamerchant::MIVACONF") ;
	system ("mv $mivamerchant::MIVAAUTH.tmp $mivamerchant::MIVAAUTH") ;

	VHMivaConf::CloseMivaVHosts() ;

	return "" ;
}

sub OpenMivaVHosts
{
	if ( mivamerchant::LoadMivaVHosts() == 0 ) {
		return "Unable to tie $mivamerchant::MIVADB" ;
	}
	else {
		return "" ;
	}
}

sub AddToMivaConf
{
	my ($record) = @_ ;

	mivamerchant::AddMivaVHost ($record) ;
}

sub CloseMivaVHosts
{
	mivamerchant::CloseMivaVHosts() ;
}

sub GetMivaVHosts
{
	my ($hashref) = $_[0] ;

	mivamerchant::GetMivaVHosts($hashref) ;
}

sub DelMivaVHost
{
	mivamerchant::DelMivaVHost ($_[0]) ;
}

return 1 ;
